import builtins
from __builtin__ import list, dict, tuple, set

class list(list):
    "\n    list() -> new empty list\n    list(iterable) -> new list initialized from iterable's items\n    "

    def count(self, value):
        ' L.count(value) -> integer -- return number of occurrences of value '
        v1 = 0
        counter = v1
        for (v2, v3) in builtins.enumerate(self):
            x = v3
            v4 = (x == value)
            if v4:
                v5 = 1
                _counter = counter
                counter += v5
        return counter

    def extend(self, iterable):
        ' L.extend(iterable) -- extend list by appending elements from the iterable '
        for (v6, v7) in builtins.enumerate(iterable):
            x = v7
            self.append(x)
    v8 = 0

    def index(self, value, start=v8, stop=None):
        '\n        L.index(value, [start, [stop]]) -> integer -- return first index of value.\n        Raises ValueError if the value is not present.\n        '
        v10 = (stop is not None)
        if v10:
            v11 = self[start:stop]
            v9 = v11
        else:
            v12 = self[start:]
            v9 = v12
        l = v9
        i = start
        for (v13, v14) in builtins.enumerate(l):
            x = v14
            v15 = (x == value)
            if v15:
                return i
            v16 = 1
            _i = i
            i += v16
        else:
            v18 = str(value)
            v19 = ' is not in the list'
            v17 = (v18 + v19)
            v20 = ValueError(v17)
            raise v20

    def insert(self, index, p_object):
        ' L.insert(index, object) -- insert object before index '
        v22 = len(self)
        v21 = (index >= v22)
        if v21:
            self.append(p_object)
            return
        v25 = 1
        v24 = (- v25)
        v23 = self[v24]
        self.append(v23)
        v29 = 1
        v28 = (index + v29)
        v31 = len(self)
        v32 = 1
        v30 = (v31 - v32)
        v33 = range(v28, v30)
        v34 = reversed(v33)
        for (v26, v27) in builtins.enumerate(v34):
            i = v27
            v37 = 1
            v36 = (i - v37)
            v35 = self[v36]
            self[i] = v35
        self[index] = p_object

    def pop(self, index=None):
        '\n        L.pop([index]) -> item -- remove and return item at index (default last).\n        Raises IndexError if list is empty or index is out of range.\n        '
        v38 = (index is None)
        if v38:
            v39 = super(list, self)
            v40 = v39.pop()
            return v40
        else:
            v44 = len(self)
            v45 = 1
            v43 = (v44 - v45)
            v46 = range(index, v43)
            for (v41, v42) in builtins.enumerate(v46):
                i = v42
                v49 = 1
                v48 = (i + v49)
                v47 = self[v48]
                self[i] = v47
        self.pop()

    def remove(self, value):
        '\n        L.remove(value) -- remove first occurrence of value.\n        Raises ValueError if the value is not present.\n        '
        v50 = (value not in self)
        if v50:
            raise ValueError
        v51 = self.index(value)
        idx = v51
        self.pop(idx)

    def reverse(self):
        ' L.reverse() -- reverse *IN PLACE* '
        v54 = len(self)
        v55 = 2
        v53 = (v54 / v55)
        v56 = 1
        v52 = (v53 + v56)
        k = v52
        v59 = 0
        v60 = range(v59, k)
        for (v57, v58) in builtins.enumerate(v60):
            i = v58
            v63 = (- i)
            v62 = self[v63]
            v61 = v62
            v65 = self[i]
            v64 = v65
            self[i] = v61
            v66 = (- i)
            self[v66] = v64

    def sort(self, cmp=None, key=None, reverse=False):
        '\n        L.sort(cmp=None, key=None, reverse=False) -- stable sort *IN PLACE*;\n        cmp(x, y) -> -1, 0, 1\n        '
        v67 = (cmp is None)
        if v67:

            def v68(a, b):
                v69 = (a - b)
                return v69
            cmp = v68
        v72 = 1
        v73 = len(self)
        v74 = range(v72, v73)
        for (v70, v71) in builtins.enumerate(v74):
            i = v71
            j = i
            v77 = 0
            v76 = (j > v77)
            if v76:
                v79 = self[j]
                v82 = 1
                v81 = (j - v82)
                v80 = self[v81]
                v83 = cmp(v79, v80)
                if v83:
                    v84 = (not reversed)
                    v78 = v84
                else:
                    v78 = v83
                v75 = v78
            else:
                v75 = v76
            while v75:
                v88 = 1
                v87 = (j - v88)
                v86 = self[v87]
                v85 = v86
                v90 = self[j]
                v89 = v90
                self[j] = v85
                v92 = 1
                v91 = (j - v92)
                self[v91] = v89
                v93 = 1
                _j = j
                j -= v93
                v96 = 0
                v95 = (j > v96)
                if v95:
                    v98 = self[j]
                    v101 = 1
                    v100 = (j - v101)
                    v99 = self[v100]
                    v102 = cmp(v98, v99)
                    if v102:
                        v103 = (not reversed)
                        v97 = v103
                    else:
                        v97 = v102
                    v94 = v97
                else:
                    v94 = v95
                v75 = v94

    def __delitem__(self, y):
        ' x.__delitem__(y) <==> del x[y] '
        v104 = isinstance(y, int)
        if v104:
            v105 = len(self)
            l = v105
            v108 = 0
            v107 = (y < v108)
            if v107:
                v109 = (l + y)
                v106 = v109
            else:
                v106 = y
            y = v106
            v112 = 0
            v111 = (y < v112)
            if v111:
                v110 = v111
            else:
                v113 = (y >= l)
                v110 = v113
            if v110:
                v114 = 'list index out of range'
                v115 = IndexError(v114)
                raise v115
            v119 = 1
            v118 = (y + v119)
            v120 = len(self)
            v121 = range(v118, v120)
            for (v116, v117) in builtins.enumerate(v121):
                i = v117
                v123 = 1
                v122 = (i - v123)
                v124 = self[i]
                self[v122] = v124
            self.pop()
        else:
            v125 = isinstance(y, slice)
            if v125:
                v126 = len(self)
                l = v126
                v129 = y.start
                v128 = (v129 is not None)
                if v128:
                    v130 = y.start
                    v127 = v130
                else:
                    v131 = 0
                    v127 = v131
                i = v127
                v134 = y.stop
                v133 = (v134 is not None)
                if v133:
                    v135 = y.stop
                    v132 = v135
                else:
                    v132 = l
                j = v132
                v138 = y.step
                v137 = (v138 is not None)
                if v137:
                    v139 = y.step
                    v136 = v139
                else:
                    v140 = 1
                    v136 = v140
                s = v136
                v143 = 0
                v142 = (i < v143)
                if v142:
                    v146 = (l + i)
                    v147 = 0
                    v145 = (v146 < v147)
                    if v145:
                        v148 = 0
                        v144 = v148
                    else:
                        v149 = (l + i)
                        v144 = v149
                    v141 = v144
                else:
                    v151 = (i < l)
                    if v151:
                        v150 = i
                    else:
                        v150 = l
                    v141 = v150
                i = v141
                v154 = 0
                v153 = (j < v154)
                if v153:
                    v157 = (l + j)
                    v158 = 0
                    v156 = (v157 < v158)
                    if v156:
                        v159 = 0
                        v155 = v159
                    else:
                        v160 = (l + j)
                        v155 = v160
                    v152 = v155
                else:
                    v162 = (j < l)
                    if v162:
                        v161 = j
                    else:
                        v161 = l
                    v152 = v161
                j = v152
                v163 = range(i, j, s)
                f = v163
                v164 = (not f)
                if v164:
                    return
                v165 = min(i, j)
                m = v165
                v166 = []
                v169 = 0
                v170 = range(v169, l)
                v171 = zip(v170, self)
                v172 = list(v171)
                for (v167, v168) in builtins.enumerate(v172):
                    v173 = v168
                    v175 = 0
                    v174 = v173[v175]
                    idx = v174
                    v177 = 1
                    v176 = v173[v177]
                    x = v176
                    v179 = (idx >= m)
                    if v179:
                        v180 = (idx not in f)
                        v178 = v180
                    else:
                        v178 = v179
                    if v178:
                        v166.append(x)
                new = v166
                v183 = range(m, l)
                for (v181, v182) in builtins.enumerate(v183):
                    idx = v182
                    self.pop()
                self.extend(new)

    def __delslice__(self, i, j):
        '\n        x.__delslice__(i, j) <==> del x[i:j]\n\n                   Use of negative indices is not supported.\n        '
        v184 = 1
        v185 = slice(i, j, v184)
        self.__delitem__(v185)

    def __getslice__(self, i, j):
        '\n        x.__getslice__(i, j) <==> x[i:j]\n\n                   Use of negative indices is not supported.\n        '
        v186 = len(self)
        l = v186
        v189 = 0
        v188 = (i < v189)
        if v188:
            v192 = (l + i)
            v193 = 0
            v191 = (v192 < v193)
            if v191:
                v194 = 0
                v190 = v194
            else:
                v195 = (l + i)
                v190 = v195
            v187 = v190
        else:
            v187 = i
        i = v187
        v197 = (l < j)
        if v197:
            v196 = l
        else:
            v196 = j
        j = v196
        v198 = []
        v201 = range(i, j)
        for (v199, v200) in builtins.enumerate(v201):
            idx = v200
            v202 = self[idx]
            v198.append(v202)
        re = v198
        return re
    v203 = ()

    def __init__(self, seq=v203):
        "\n        list() -> new empty list\n        list(iterable) -> new list initialized from iterable's items\n        # (copied from class doc)\n        "
        for (v204, v205) in builtins.enumerate(seq):
            x = v205
            self.append(x)

class dict(dict):
    "\n    dict() -> new empty dictionary\n    dict(mapping) -> new dictionary initialized from a mapping object's\n        (key, value) pairs\n    dict(iterable) -> new dictionary initialized as if via:\n        d = {}\n        for k, v in iterable:\n            d[k] = v\n    dict(**kwargs) -> new dictionary initialized with the name=value pairs\n        in the keyword argument list.  For example:  dict(one=1, two=2)\n    "

    def copy(self):
        ' D.copy() -> a shallow copy of D '
        v206 = dict(self)
        return v206

    @staticmethod
    def fromkeys(S, v=None):
        '\n        dict.fromkeys(S[,v]) -> New dict with keys from S and values equal to v.\n        v defaults to None.\n        '
        v207 = {}
        for (v208, v209) in builtins.enumerate(S):
            k = v209
            v207[k] = v
        return v207

    def get(self, k, d=None):
        ' D.get(k[,d]) -> D[k] if k in D, else d.  d defaults to None. '
        v211 = (k in self)
        if v211:
            v212 = self[k]
            v210 = v212
        else:
            v210 = d
        return v210

    def items(self):
        " D.items() -> list of D's (key, value) pairs, as 2-tuples "
        v213 = []
        for (v214, v215) in builtins.enumerate(self):
            k = v215
            v217 = self[k]
            v216 = (k, v217)
            v213.append(v216)
        return v213

    def keys(self):
        " D.keys() -> list of D's keys "
        v218 = []
        for (v219, v220) in builtins.enumerate(self):
            k = v220
            v218.append(k)
        return v218

    def _dict__update_impl(self, E=None, **F):
        v221 = (E is not None)
        if v221:
            v222 = 'keys'
            v223 = hasattr(E, v222)
            if v223:
                for (v224, v225) in builtins.enumerate(E):
                    k = v225
                    v226 = E[k]
                    self[k] = v226
            else:
                for (v227, v228) in builtins.enumerate(E):
                    v229 = v228
                    v231 = 0
                    v230 = v229[v231]
                    k = v230
                    v233 = 1
                    v232 = v229[v233]
                    v = v232
                    self[k] = v
        for (v234, v235) in builtins.enumerate(F):
            k = v235
            v236 = F[k]
            self[k] = v236

    def update(self, E=None, **F):
        '\n        D.update([E, ]**F) -> None.  Update D from dict/iterable E and F.\n        If E present and has a .keys() method, does:     for k in E: D[k] = E[k]\n        If E present and lacks .keys() method, does:     for (k, v) in E: D[k] = v\n        In either case, this is followed by: for k in F: D[k] = F[k]\n        '
        self._dict__update_impl(E, **F)

    def values(self):
        " D.values() -> list of D's values "
        v237 = []
        for (v238, v239) in builtins.enumerate(self):
            k = v239
            v240 = self[k]
            v237.append(v240)
        return v237

    def __init__(self, seq=None, **kwargs):
        "\n        dict() -> new empty dictionary\n        dict(mapping) -> new dictionary initialized from a mapping object's\n            (key, value) pairs\n        dict(iterable) -> new dictionary initialized as if via:\n            d = {}\n            for k, v in iterable:\n                d[k] = v\n        dict(**kwargs) -> new dictionary initialized with the name=value pairs\n            in the keyword argument list.  For example:  dict(one=1, two=2)\n        # (copied from class doc)\n        "
        self._dict__update_impl(seq, **kwargs)
    pass
v242 = '__main__'
v241 = (__name__ == v242)
if v241:
    v244 = 1
    v245 = 2
    v246 = 3
    v247 = 4
    v243 = [v244, v245, v246, v247]
    v248 = list(v243)
    x = v248
    v249 = 0
    v250 = 5
    x.insert(v249, v250)
    print(x)
    v252 = 1
    v254 = 1
    v253 = (- v254)
    v251 = x[v252:v253]
    print(v251)
    v256 = 11
    v257 = 12
    v255 = x[v256:v257]
    print(v255)
